--[[
Name: KittyPurr
Project Revision: 25
File Revision: 25 
Author(s): Netrox
Website: http://wow.curseforge.com/addons/kittypurr/
SVN: svn://svn.curseforge.net/wow/kittypurr/mainline/trunk
License: All rights reserved.
]]

if select(2, UnitClass("player")) ~= "DRUID" then return end

KittyPurr = CreateFrame('frame')
local KittyPurr = KittyPurr

KittyPurr:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
KittyPurr:RegisterEvent("ADDON_LOADED")


function KittyPurr:ADDON_LOADED(event, addon)
	if addon == "KittyPurr" then
        KittyPurrDB = KittyPurrDB or { purrs = 0, }

		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil

		if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
    end
end

local OnUpdate
function KittyPurr:PLAYER_LOGIN(event)
    self.db = KittyPurrDB
    self.doPrint = false
    self.doRoar = false
    
    self.minTime = 1 * 60
    self.maxTime = 5 * 60
    
    self.SavageRoar = GetSpellInfo(52610)

    self.nextPurr = math.random(self.minTime, self.maxTime)
    self.Print("Next /purr in ~"..tostring(self.nextPurr).." seconds.")


	SLASH_KittyPurr1 = "/kittypurr"
	SLASH_KittyPurr2 = "/purred"
	SlashCmdList["KittyPurr"] = function()
        DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99KittyPurr|r: You /purr'ed "..tostring(self.db.purrs).." times.")
    end

    -- Register Events
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
    --self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
        
    -- Set OnUpdate Handler
    self:SetScript("OnUpdate", OnUpdate)
end

local active = false
function KittyPurr:UNIT_SPELLCAST_SUCCEEDED(event, unit, spell)
    if self.doRoar and unit == "player" and spell == self.SavageRoar then
        DoEmote("roar", 1)
    end
end

local lastint = floor(GetTime() + 0.5)
function OnUpdate(self)
	local nowint = floor(GetTime() + 0.5)
	if nowint == lastint then return end
    
    
    if nowint - lastint > self.nextPurr then
        if not self.avoidPvpPurr and self.isCatForm then
            DoEmote("purr", 1)
            self.db.purrs = self.db.purrs + 1
            self.nextPurr = math.random(self.minTime, self.maxTime)
            self:Print("Next /purr in ~"..tostring(self.nextPurr).." seconds.")
        end
        lastint = nowint
    end        
end

function KittyPurr:PLAYER_ENTERING_WORLD()
    local inInstance, instanceType = IsInInstance()
    if inInstance and (instanceType == "pvp" or instanceType == "arena") then
        self.avoidPvpPurr = true
        self:Print("avoidPvpPurr == true")
    else
        self.avoidPvpPurr = false
        self:Print("avoidPvpPurr == false")
    end
    -- Check for Cat Form, just to be sure.
    self:UPDATE_SHAPESHIFT_FORM()
end

function KittyPurr:UPDATE_SHAPESHIFT_FORM()
    if UnitAura("player", GetSpellInfo(768)) then
        self.isCatForm = true      
        self:Print("isCatForm == true")
        if GetSpecialization() == 2 then
            self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
        end
    else
        self.isCatForm = false
        self:Print("isCatForm == false")
        if GetSpecialization() == 2 then
            self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
        end
    end
end

function KittyPurr:Print(t)
    if self.doPrint then DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99KittyPurr|r: "..tostring(t)) end
end
